//********************************* Mouse ****************************
void mousePressed() {
    //----------------------------------------------------------------- test pupitre ----------------------------------------------------------
    pupitre.test_pupitres();
    pupitre.test_pupitre();
    if (mouseButton == LEFT) {
        boolean sortie = false;
        //----------------------------------------------- appui sur le gros bouton bleu en bas à droite ------------------------------------
        if (mouseX > (width-1366)/2+1280 && mouseX < (width-1366)/2+1350 
         && mouseY > (height-200)+145    && mouseY < (height-200)+180) {
            //------------------------------------ supprime éventuel du pupitre -------------------------
            if (choix_train != -1 && affiche_exit) {
                Train train = pupitre.trains[choix_train];
                boolean moteur = false;
                for (Vehicule veh0 : train.compo_train) {
                    if (veh0.moteur) {
                        moteur = true;
                        break;
                    }
                }
                if (!moteur) {
                    liste_trains.set(choix_train-1, 0);
                    index = liste_trains.size()-1;                                                                                                           //  on part de la fin
                    while (index > -1) {
                        if (index+1 > choix_train) {                                                                                                         //  index+1 correspond à un numéro de train. Si c'est le bon train...
                            if (liste_trains.get(index) != 0) {                                                                                              //  si on est sur un train moteur
                                liste_trains.set(index, liste_trains.get(index)-1);                                                                          //  on décrémente le numéro de pupitre
                            }
                            index--;                                                                                                                         //  on remonte d'une ligne
                        } else {
                            break;
                        }
                    }
                    
                }
            }          
            if (supprime_train) {
                supprime_train(choix_train);
            } else {
                if (abs(numero_attelage) > 0 && !affiche_exit) {
                    //----------------------------- validation attelage ----------------------------------------
                    if (abs(numero_attelage) > 0) {
                        Train train = pupitre.trains[choix_train];                                                                                           //  c'est le train affiché dans le panneau
                        if (numero_attelage > 0) {
                            //******************************* on découpe le train ***********************************
                            nb_pupitres = 0;
                            for (int numero_pupitre0 : liste_trains) {
                                if (numero_pupitre0 != 0) {
                                    nb_pupitres++;
                                }
                            }
                            int nb_trains   = liste_trains.size();
                            boolean moteur1 = false;
                            for (int i = 0; i <= numero_attelage; i++) {
                                if (train.compo_train.get(i).moteur) {
                                    moteur1 = true;
                                    break;
                                }                                
                            }
                            if (moteur1) {                                                                                                                   //  le train1 était en tire
                                //---------------------------- on construit l'itinéraire du train2 ------------
                                train.iti_deuxieme = new Itineraire();                                                                                       //  on crée train.iti_deuxieme
                                tous_iti.add(train.iti_deuxieme);                                                                                            //  on l'ajoute aux itinéraires
                                int compteur_paves_iti_train    = -1;
                                int compteur_paves_iti_deuxieme = -1;
                                for (Pave pave0 : train.iti_train.paves_composant_iti) {
                                    compteur_paves_iti_train++;
                                    if (pave0.occupe) {
                                        compteur_paves_iti_deuxieme++;
                                        train.iti_train.paves_composant_iti.get(compteur_paves_iti_train).numero_train2 = nb_trains+1;
                                        train.iti_deuxieme.paves_composant_iti.add(train.iti_train.paves_composant_iti.get(compteur_paves_iti_train));       //  on l'initialise avec train.iti_train
                                        train.iti_deuxieme.lames[compteur_paves_iti_deuxieme]       = pave0.lames;                    
                                        train.iti_deuxieme.entree_pave[compteur_paves_iti_deuxieme] = pave0.entree_pave;
                                    }
                                }
                                train.iti_deuxieme.pave_debut     = train.iti_deuxieme.paves_composant_iti.get(0);
                                train.iti_deuxieme.pave_premier   = train.iti_deuxieme.paves_composant_iti.get(0);
                                train.iti_deuxieme.pave_fin       = train.iti_deuxieme.paves_composant_iti.get(compteur_paves_iti_deuxieme);
                                for (Zone zone1 : toutes_zones) {                                                                                            //  recherche de la zone début d'iti_suivant
                                    if (zone1.paves_composant_zone.contains(train.iti_deuxieme.pave_debut)) {
                                        train.iti_deuxieme.zone_debut = zone1;                                                                               //  on a trouvé la zone début d'iti_suivant
                                        break;
                                    }
                                }
                                for (Zone zone1 : toutes_zones) {                                                                                            //  recherche de la zone de fin d'iti_suivant
                                    if (zone1.paves_composant_zone.contains(train.iti_deuxieme.pave_fin)) {
                                        train.iti_deuxieme.zone_fin = zone1;                                                                                 //  on a trouvé la zone de fin d'iti_suivant
                                        break;
                                    }
                                }
                                //-------------- on construit le train2 ------------------------
                                pupitre.trains[nb_trains+1] = new Train();
                                pupitre.trains[nb_trains+1].nb_vehicules = 0;
                                int nb_veh = train.compo_train.size();
                                boolean moteur2 = false;                                                                                                     //  on va tester si le train2 (après découpe) est moteur
                                for (int i = numero_attelage; i < nb_veh; i++) {
                                    vehicule = new VehiculeCopy(train.compo_train.get(i).ident);
                                    pupitre.trains[nb_trains+1].compo_train.add(vehicule.copy());
                                    pupitre.trains[nb_trains+1].nb_vehicules++;
                                    if (train.compo_train.get(i).moteur && !moteur2) {
                                        moteur2 = true;
                                    }
                                }
                                pupitre.trains[nb_trains+1].coord_debut_train = train.iti_train.points_composant_iti.get(train.compo_train.get(numero_attelage).position).coord;
                                pupitre.trains[nb_trains+1].iti_train         = train.iti_deuxieme;
                                //------------------ on raccourcit le train1 ---------------------------
                                int index = train.compo_train.size()-1;
                                int borne = train.compo_train.size()-pupitre.trains[nb_trains+1].compo_train.size()-1;
                                while (index > borne) {
                                    train.compo_train.remove(index);
                                    index--;
                                }
                                train.compo_train.trimToSize();
                                numero_attelage = 0;
                                //---------------------- on passe au train2 -----------------------
                                nb_trains++;
                                train = pupitre.trains[nb_trains];                                                                                           //  c'est le train qui va rester
                                if (moteur2) {
                                    nb_pupitres++;
                                    liste_trains.append(nb_pupitres);                                                                                        //  on démarre à 1
                                    train.numero_pupitre           = nb_pupitres;
                                    train_pupitre(itineraire.numero_train);
                                    pupitre.bloque[numero_pupitre] = true;
                                    hauteur_curseur[num_train_pupitre] = 0;
                                } else {
                                    liste_trains.append(0);
                                    train.numero_pupitre           = 0;
                                }
                                train.numero_train             = nb_trains;
                                train.iti_train.numero_train   = nb_trains;
                                train.debut_train              = train.compo_train.get(0).position;
                                train.iti_train.cycle          = false;
                                train.iti_train.iti_en_attente = false;
                                train.iti_train.duree_arret    = 0;
                                train.iti_train.iti_suivant    = null;
                                train.iti_train.iti_change     = true;
                                train.iti_train.iti_affiche    = true;
                                prolonge_numero_train(train.iti_train);
                            } else {                                                                                                                         //  le train1 était en pousse
                                texte_affiche_train   = "On ne peut pas laisser une partie de train sans élément moteur si elle est située à l'AVANT. Effacez la route actuelle et inversez le sens de la nouvelle route";
                                couleur_affiche_train = POURPRE;
                                train.compo_train.get(numero_attelage).attele_fin = false;
                                affiche_exit          = true;
                                sortie                = true;
                            }
                      } else {
                            //************************************ on aboute les trains *************************************
                            if (abs(numero_attelage+1) == train.nb_vehicules-1 || numero_attelage == -1000) {                                                //  uniquement si on est sur le dernier attelage
                                for (Itineraire iti0 : tous_iti) {
                                    if (train.iti_train.paves_composant_iti.contains(iti0.pave_debut)                                                        //  si l'itinéraire du train contient le pavé début de l'iti0 en cours
                                     && train.iti_train.paves_composant_iti.contains(iti0.pave_fin)                                                          //  ET si l'itinéraire du train contient le pavé fin de l'iti0 en cours
                                     && train.iti_train != iti0) {                                                                                           //  ET si les itinéraires sont différents
                                        int compt = -1;
                                        for (Pave pave0 : train.iti_train.paves_composant_iti) {                                                             //  on balaie tous les pavés de l'itinéraire jusqu'à trouver un pavé qui n'a plus le numéro de train du train
                                            compt++;
                                            if (pave0.numero_train1 != train.iti_train.numero_train) {
                                                break;
                                            }
                                        }
                                        train.iti_train.cote_rouge_cli = 1-train.iti_train.entree_pave[compt-1];                                             //  le coté du signal est le dernier signal vu par le train
                                        train.iti_train.pave_rouge_cli = train.iti_train.paves_composant_iti.get(compt-1);                                   //  le pavé qui recevra le rouge clignotant
                                        train.iti_train.pave_rouge_cli.rouge_clignotant[train.iti_train.cote_rouge_cli] = true;                              //  le pavé du signal est le dernier pavé contenant le signal
                                        Train train_trouve = pupitre.trains[iti0.numero_train];                                                              //  on mémorise le train qui va s'accrocher
                                        for (Pave pave0 : iti0.paves_composant_iti) {                                                                        //  la zone commune doit avoir les deux numéros de train
                                            pave0.numero_train2 = pave0.numero_train1;
                                            pave0.numero_train1 = train.iti_train.numero_train;
                                        }
                                        prolonge_numero_train(train.iti_train);                                                                              //  on prolonge le numéro du train
                                        //----------------------- recherche du point le plus près -----------------------------
                                        train.position_proche = 0;
                                        for (int pos = 0; pos < train.iti_train.points_composant_iti.size(); pos++) {
                                            if (PVector.dist(train.iti_train.points_composant_iti.get(pos).coord, train_trouve.coord_debut_train) < 0.1) {
                                                train.position_proche = pos;                                                                                 //  position du début du train trouvé
                                                break;
                                            }
                                        }
                                        int position_fin = 0;
                                        for (int pos = 0; pos < train.iti_train.points_composant_iti.size(); pos++) {
                                            if (PVector.dist(train.iti_train.points_composant_iti.get(pos).coord, train_trouve.coord_fin_train) < 0.1) {
                                                position_fin = pos;                                                                                          //  position de la fin du train trouve
                                                break;
                                            }
                                        }
                                        if (train.position_proche > position_fin) {                                                                          // mise à jour du point le plus proche pour le train trouvé
                                            train.position_proche = position_fin; 
                                        }
                                        //------------------- adduction d'un "signal" ---------------
                                        train.iti_train.position_signaux_iti.append(train.position_proche);
                                        train.iti_train.position_signaux_iti.sort();
                                        train.vitesse  = 10;
                                        train.consigne = 10;
                                        train.nouvelle_position = train.position_proche;
                                    }
                                }
                            }
                        }
                        affiche_exit          = true;
                    }
                } else {
                    //---------------------------------- mise à jour et sortie -----------------------------
                    if (choix_train != -1) {
                        Train train = pupitre.trains[choix_train];
                        if (train.compo_train.size() == train.compo_train_bis.size()                                                                         //--- si la compo_train et la compo_train_bis ont la même taille
                         || train.compo_train_bis.size() == 0 ) {                                                                                            //  OU si compo_train_bis est vide       
                            affiche_trains              = false;                                                                                             //  on sort sans rien changer
                            affiche_train_sauve_initial = false;
                        } else {                                                                                                                             //--- on a changé quelque chose
                            train.compo_train.clear();                                                                                                       //  on efface compo_train
                            for (Vehicule veh0 : train.compo_train_bis) {
                                train.compo_train.add(veh0);
                            }
                            boolean moteur = false;
                            for (Vehicule veh0 : train.compo_train) {
                                if (veh0.moteur) {
                                    moteur = true;
                                    break;
                                }
                            }
                            if (!moteur) {
                                liste_trains.set(choix_train-1, 0);
                            }
                        }
                        texte_affiche_train   = ".";                                                                                                         //  on réinitialise le message
                        couleur_affiche_train = BLANC;
                    } else {                                                                                                                                 //  si on n'a pas choisi de train
                        affiche_trains              = false;
                        affiche_train_sauve_initial = false;
                    }
                    affiche_exit = true;                                                                                                                     //  par défaut, c'est "Exit"
                }
            }
        }
        //--------------------------------- appui sur les autres boutons ----------------------
        if (choix_train > 0 && !sortie) {
            Train train = pupitre.trains[choix_train];
            //-------------------------------------- appui sur annulation (le petit bouton bleu en bas à gauche) ------------------------------------
            if (mouseX > (width-1366)/2+1230 && mouseX < (width-1366)/2+1265 
             && mouseY > (height-200)+145    && mouseY < (height-200)+180) {
                train.compo_train.clear();                                                                                                                   //  on efface compo_train
                train.compo_train_bis.clear();                                                                                                               //  on efface compo_train_bis
                int taille = train.compo_train_ter.size();                                                                                                   //  et on remplace par compo_train_ter
                for (int i = 0; i < taille; i++) {
                    train.compo_train.add(train.compo_train_ter.get(i));
                }
                for (int i = 0; i < taille; i++) {
                    train.compo_train.get(i).attele_fin = true;
                }
                texte_affiche_train   = ".";
                couleur_affiche_train = BLANC;
                if (supprime_train) {
                    supprime_train = false;
                    affiche_exit   = true;
                }
                texte_affiche_train   = "Annulation réussie. Vous pouvez sortir";
                couleur_affiche_train = OLIVE;
            }
            //------------------------------------------- appui sur les petits boutons haut et bas ------------------------------------------
            if (choix_train != -1) {                                                                                                                         //  si on a choisi un train
                for (int d = 0; d < 2; d++) {
                    for (int u = 0; u < 10; u++) {
                        if (train.compo_train.size() > 10*d+u) {                                                                                             //  si on a dépassé le nombre de véhicules
                            int identite = train.compo_train.get(10*d+u).ident;                                                                              //  simplification d'écriture
                            if (mouseX > (width-1366)/2+115+u*135 && mouseX < (width-1366)/2+135+u*135                                                       //  bouton du haut : véhicule 10*d+u
                             && mouseY > (height-200)+15+d*65     && mouseY < (height-200)+35+d*65) {
                                identite = max(-1, identite-1);                                                                                              //  on va en décroissant (on remonte dans la tableau)
                                vehicule = new VehiculeCopy(identite);
                                train.compo_train.set(10*d+u, vehicule.copy());
                            }            
                            if (mouseX > (width-1366)/2+115+u*135 && mouseX < (width-1366)/2+135+u*135                                                       //  bouton du bas  : véhicule 10*d+u 
                             && mouseY > (height-200)+45+d*65     && mouseY < (height-200)+65+d*65) {
                                identite = min(tous_vehicules.size()-1, identite+1);                                                                         //  on va en croissant (on descend dans le tableau)
                                vehicule = new VehiculeCopy(identite);
                                train.compo_train.set(10*d+u, vehicule.copy());
                            }
                        }
                    }
                }
            }
            //----------------------------------------------- appui sur l'attelage ------------------------------------
            if (choix_train != -1) {                                                                                                                         //  si on a choisi un train
                for (int d = 0; d < 2; d++) {
                    for (int u = 0; u < 10; u++) {
                        if (train.compo_train.size() > 10*d+u) {                                                                                             //  si on a dépassé le nombre de véhicules
                            if (mouseX > (width-1366)/2+115+u*135 && mouseX < (width-1366)/2+149+u*135 
                             && mouseY > (height-200)+35+d*65     && mouseY < (height-200)+45+d*65) {
                                numero_attelage = 0;
                                train.compo_train_bis.clear();
                                if (train.compo_train.get(10*d+u).attele_fin) {                                                                            //  il y a 10*d+u-1 pour qu'on ne puisse pas mettre un attelage tout seul au bout
                                    //-------------------------- découpe le train ----------------------------
                                    for (int i = 0; i < train.compo_train.size(); i++) {                                                                     //  on remet tous les attelages
                                        train.compo_train.get(i).attele_fin = true;
                                    }
                                    train.compo_train.get(10*d+u).attele_fin = false;                                                                        //  on efface celui qui est pointé
                                    numero_attelage   = 10*d+u+1;
                                    texte_affiche_train   = ".";
                                    couleur_affiche_train = BLANC;
                                    affiche_exit          = false;
                                    break;
                                } else {
                                    //--------------------------- recolle le train ---------------------------
                                    train.compo_train.get(10*d+u).attele_fin = true;                                                                         //  on remet l'attelage pointé
                                    for (int i = 0; i < train.compo_train.size(); i++) {                                                                     //  on sauve le train complet
                                        train.compo_train_bis.add(train.compo_train.get(i));
                                    }
                                    numero_attelage   = -10*d-u-1;
                                    if (numero_attelage == -train.compo_train.size()) {
                                        train.position_attelage = train.debut_train-train.longueur_train;
                                    } else {
                                        train.position_attelage = train.compo_train.get(10*d+u+1).position;
                                    }
                                    train.coord_attelage        = train.iti_train.points_composant_iti.get(train.position_attelage).coord;
                                    affiche_exit          = false;
                                    for (Pave pave0 : train.iti_train.paves_composant_iti) {
                                        if (pave0.numero_train2 != 0) {
                                            if (PVector.dist(train.coord_attelage, train_trouve.coord_debut_train) < 10) {
                                                Train train_trouve = pupitre.trains[pave0.numero_train2];                                                    //  train_trouve est le train qui est peut-être proche du train courant
                                                int numero_train_a_effacer = pave0.numero_train2;
                                                //--------------------------------- on est à côté du debut du train2 ----------------------------
                                                index = 0;
                                                while (index < train_trouve.compo_train.size()) {
                                                    train.compo_train.add(train_trouve.compo_train.get(index));
                                                    index++;
                                                }
                                                supprime_train(numero_train_a_effacer);
                                                train.compo_train_bis.clear();
                                                numero_attelage = 0;
                                                affiche_trains = true;
                                                for (Vehicule veh0 : train.compo_train) {
                                                    veh0.attele_fin = true;                                                                                  //  on remet l'attelage pointé
                                                }
                                            }
                                            break;
                                        }
                                    }
                                    texte_affiche_train   = ".";
                                    couleur_affiche_train = BLANC;
                                    break;
                                }
                            }
                            if (mouseX > (width-1366)/2+u*135 && mouseX < (width-1366)/2+17+u*135 
                             && mouseY > (height-200)+0+d*65 && mouseY < (height-200)+65+d*65) {                                                             //  on compte entre 0 et 65 en y (au lieu de 35 et 45) pour avoir plus de marge ici
                                 numero_attelage = -1000;
                                 train.position_attelage = train.compo_train.get(0).position;
                                 train.coord_attelage    = train.iti_train.points_composant_iti.get(train.position_attelage).coord;
                                 affiche_exit = false;
                            }                            
                        }
                    }
                }
            }
        }
    } else {                                                                                                                                                 //  clic DROIT
        //----------------------------------------------- inversion des images ------------------------------------
        if (choix_train != -1) {
            for (int d = 0; d < 2; d++) {
                for (int u = 0; u < 10; u++) {
                    if (train.compo_train.size() > 10*d+u) {                                                                                                 //  si on a dépassé le nombre de véhicules
                        if (mouseX > (width-1366)/2+17+u*135 && mouseX < (width-1366)/2+113+u*135                                                            //  bouton du haut : véhicule 10*d+u
                         && mouseY > (height-200)+17+d*65     && mouseY < (height-200)+63+d*65) {
                             train.compo_train.get(10*d+u).image_inverse = !train.compo_train.get(10*d+u).image_inverse;
                        }
                    }
                }
            }
        }
    }
    //************************************************ recherche d'itinéraires *********************************************************************************************************
    //------------------------------------------------ recherche d'itinéraires ---------------------------------------------------------------------------------------------------------
    if (itineraire_demande) {
        if (mouseButton == LEFT) {                                                                                                                           //---------------- mouseButton == LEFT-----------            
            for (int i = 1; i < INDEX_MAX; i++) {                                                                                                            //  nettoyage complet de la matrice, sauf la ligne 0 qui contient la première zone qui précède le premier appareil de voie
                for (int j = 0; j < 6; j++) {
                    iti[i][j] = 0;
                }
            }
            index    = 0;                                                                                                                                    //  index de la matrice
            fini     = false;                                                                                                                                //  l'itinéraire n'est pas fini...
            retour   = false;                                                                                                                                //  on commence par avancer
            c_boucle = 0;
            l_boucle = 0;
            if (!cherche_arrivee) {                                                                                                                          //  on cherche d'abord le point de depart...
                //----------------------------------- recherche du connecteur de depart et de c/l de ce connecteur
                tco.recherche_connecteur(true);                                                                                                              //  true = départ
                if (!pave_feu_noir.butoir[cote_feu_noir]) {
                    if (depart != null) {                                                                                                                    //  on a trouvé un connecteur de départ
                        if (pave_feu_noir.numero_train1 > 0 && pupitre.trains[pave_feu_noir.numero_train1].vitesse > 0) {                                    //  on a un pavé affecté et le train roule
                            texte_affiche    = "Il y a un train qui roule sur cette route. On ne peut donc ni prolonger ni effacer la route. Il faut d'abord arrêter le train";
                            couleur_affichee = POURPRE;
                            efface_recherche();
                        } else {
                            pave_feu_noir.feu_noir[cote_feu_noir] = true;
                            texte_affiche    = "Cliquez GAUCHE sur le point d'arrivée pour chercher une route. Si départ = arrivée, effacement de toutes les routes de ce train. Cliquez DROIT pour ne rien faire";
                            couleur_affichee = SABLE;                      
                            Pave pave_du_depart = pave_feu_noir;
                            if ((pave_du_depart.feu_noir[0])                                                                                                                                                                                              
                             || (pave_du_depart.feu_noir[1])
                             || (pave_du_depart.numero_train1 >= 0)) {                                                                                       //  on ne peut démarrer que depuis un feu noir, d'une zone vide non réservée ou d'une zone occupée
                                boolean sortie  = false;                                                                                                     //  initialisation de la sortie
                                //*************************************** effacement des itinéraires en cours jusqu'à un certain point ******************
                                if (tous_iti.size() != 0) {                                                                                                  //  il faut qu'il y ait des itinéraires à effacer...
                                    //--------------------- recherche de l'itinéraire qui arrive au point de départ -----------------------
                                    int numero_train_dernier_iti   = 0;
                                    int rang_dernier_iti           = -1;
                                    boolean trouve = false;
                                    for (Itineraire iti0 : tous_iti) {                                                                                       //  on balaie tous les itinéraires
                                        rang_dernier_iti++;
                                        if (abs(iti0.numero_train) == 1000) {                                                                                //--- on essaie de prolonger un itinéraire qui n'a pas de train
                                            texte_affiche    = "Vous ne pouvez pas prolonger une route qui n'a pas de train";
                                            couleur_affichee = SABLE;
                                            sortie = true;
                                            efface_recherche();
                                            break;
                                        } else {                                                                                                             //--- on essaie de prolonger un itinéraire qui a un train
                                            if (iti0.pave_fin.ID_zone.equals(pave_du_depart.ID_zone)) {                                                      //  si le nom de zone du dernier pavé de l'itinéraire est le même que celui du pavé de départ
                                                dernier_itineraire         = iti0;                                                                           //  on a trouvé le dernier itinéraire
                                                numero_train_dernier_iti   = abs(iti0.numero_train);                                                         //  on a son numéro de train
                                                train_pupitre(numero_train_dernier_iti);
                                                trouve                     = true;
                                                break;                                                                                                       //  et, comme on s'arrête, on a son rang en partant du haut
                                            }
                                        }
                                    }
                                    //----------------------- on prolonge un itinéraire existant --------------------
                                    if (trouve) {
                                        if (!dernier_itineraire.cycle || (dernier_itineraire.cycle && premier_pave != null)) {                               //  si le dernier itinéraire n'est pas un cycle OU si le dernier itinéraire est un cycle complet
                                            int compteur_paves = 0;
                                            for (Pave pave0 : dernier_itineraire.paves_composant_iti) {                                                      //  on efface tous les feux noirs, sauf le premier
                                                if (pave0.feu_noir[0]) {
                                                    compteur_paves++;
                                                    if (compteur_paves != 1) {
                                                        pave0.feu_noir[0]       = false;
                                                        pave0.feu_clignotant[0] = false;
                                                    }
                                                }
                                                if (pave0.feu_noir[1]) {
                                                    compteur_paves++;
                                                    if (compteur_paves != 1) {
                                                        pave0.feu_noir[1]       = false;
                                                        pave0.feu_clignotant[1] = false;
                                                    }
                                                }
                                            }
                                            //-------------------- effacement de tous les itinéraires avec le meme numero train en négatif -------------
                                            int index = tous_iti.size()-1;
                                            while (index > rang_dernier_iti) {                                                                               //  on balaie tous les itinéraires en partant du bas, mais pas plus haut que le rang précédent
                                                if (tous_iti.get(index).numero_train == -numero_train_dernier_iti) {                                         //  on recherche tous les itinéraires dont le numero_train est le même, en négatif
                                                    for (Itineraire iti0 : tous_iti) {
                                                        if (iti0.iti_suivant == tous_iti.get(index)) {                                                       //  si on le trouve, il n'aura donc plus de suivant
                                                            iti0.iti_suivant = null;
                                                            break;                                                                                           //  on sort, deux itinéraires ne pouvant pas avoir le même suivant
                                                        }                                        
                                                    }
                                                    for (Pave pave0 : tous_iti.get(index).paves_composant_iti) {                                             //  effacement de tous les feux noirs de l'itinéraire effacé
                                                        pave0.feu_noir[0]       = false;
                                                        pave0.feu_clignotant[0] = false;
                                                        pave0.feu_noir[1]       = false;
                                                        pave0.feu_clignotant[1] = false;                                                    
                                                    }
                                                    tous_iti.remove(index);                                                                                  //  on efface l'itinéraire dans l'arrayList
                                                }
                                                index--;
                                            }
                                            tous_iti.trimToSize();                                                                                           //  on n'a plus que les itinéraires précédent le point de départ dans tous_iti
                                            //----------------- effacement des iti_tempo qui ne sont pas dans tous_iti --------------------------
                                            index = tous_iti_tempo.size()-1;
                                            trouve = false;
                                            while (index > 0) {                                                                                              //  on balaie tous les itinéraires en partant du bas
                                                for (Itineraire iti0 : tous_iti) {
                                                    if (tous_iti_tempo.get(index) == iti0) {                                                                 //  on recherche tous les itinéraires qui n'existent plus dans tous_iti
                                                        trouve = true;
                                                        break;
                                                    }
                                                }
                                                if (!trouve) {                                                                                               //  si on n'en a pas trouvé, il faut les effacer dans tous_iti_tempo
                                                    for (Pave pave0 : tous_iti_tempo.get(index).paves_composant_iti) {                                       //  on n'affiche plus les pavés temporaires
                                                        pave0.affiche_iti_tempo = false;
                                                    }
                                                    tous_iti_tempo.remove(index);                                                                            //  on retire l'itinéraire de l'arrayList
                                                }
                                                index--;
                                            }
                                            tous_iti_tempo.trimToSize();                                                                                     //  on n'a plus que les itinéraires précédent le point de départ dans_tous_iti_tempo
                                            pave_feu_noir.feu_noir[cote_feu_noir]       = true;                                                              //  on met un feu noir au point de départ
                                            pave_feu_noir.feu_clignotant[cote_feu_noir] = false;                                                             //  ce feu n'est pas clignotant
                                        }
                                    } else {
                                        if (!sortie) {
                                            if (!(pave_du_depart.numero_train1 > 0 && pave_du_depart.occupe)) {
                                                if (premier_pave != null) {                                                                                  //--- on est sur un cycle en cours d'élaboration
                                                    texte_affiche    = "Choisissez un feu noir pour continuer le cycle";
                                                    couleur_affichee = POURPRE;
                                                    sortie = true;
                                                    efface_recherche();
                                                } else {                                                                                                     //--- on n'est pas sur un cycle
                                                    boolean trouve_pave = false;
                                                    for (Itineraire iti0 : tous_iti) {
                                                        if (iti0.paves_composant_iti.contains(pave_du_depart)) {                                           
                                                            trouve_pave = true;
                                                        }
                                                    }
                                                    if (trouve_pave) {
                                                        texte_affiche    = "Choisissez un feu noir pour continuer le chaînage ou démarrez un nouveau chaînage";
                                                        couleur_affichee = POURPRE;
                                                        sortie = true;
                                                        efface_recherche();
                                                   } else {
                                                        pave_feu_noir.feu_noir[cote_feu_noir]       = true;                                                  //  on met un feu noir au point de départ
                                                        pave_feu_noir.feu_clignotant[cote_feu_noir] = false;                                                 //  ce feu n'est pas clignotant
                                                   }
                                                }
                                            }
                                        }
                                    }
                                } else {
                                    pave_feu_noir.feu_noir[cote_feu_noir]       = true;                                                                      //  on met un feu noir au point de départ
                                    pave_feu_noir.feu_clignotant[cote_feu_noir] = false;                                                                     //  ce feu n'est pas clignotant
                                }
                                if (!sortie) {
                                    if (iti_cycle) {
                                        cursor(curseur_cycle, 0, 0);                                                                                         //  changement de curseur pour sélectionner le point d'arrivée dans le cas d'un cycle
                                    } else {
                                        cursor(curseur_iti, 0, 0);                                                                                           //  changement de curseur pour sélectionner le point d'arrivée dans les autres cas
                                    }
                                }
                            } else {
                                texte_affiche = "Vous ne pouvez pas choisir ce point de départ : soit vous partez d'un feu noir, soit vous partez d'une zone vide";
                                couleur_affichee = POURPRE;
                                efface_recherche();
                            }
                        }
                    } else {
                        cursor(curseur_iti, 0, 0);                                                                                                           //  changement de curseur pour selectionner le point d'arrivee
                        texte_affiche = "Point de départ introuvable";
                        couleur_affichee = POURPRE;
                        efface_recherche();
                    }
                } else {
                    texte_affiche = "Le point de départ ne peut pas être un butoir";
                    couleur_affichee = POURPRE;
                    efface_recherche();
                }
            } else {                                                                                                                                         //  on cherche maintenant le point d'arrivee                    
                //----------------------------------- recherche du connecteur d'arrivee et de c/l de ce connecteur                
                tco.recherche_connecteur(false);                                                                                                             //  false = arrivée
                if (arrivee != null) {
                    pave_feu_noir.feu_noir[cote_feu_noir] = true;
                    cursor(ARROW);
                    trouve       = false;
                    tout_teste   = false;                                                                                                                    //  au départ, on n'a évidemment pas tout testé
                    if (!(c_trouve == c_arrivee && l_trouve == l_arrivee)) {                                                                                 //  normalement, le depart n'est pas au meme point que l'arrivee
                            tco.recherche_itineraires(depart, c_depart, l_depart);                                                                           //  lance la recherche
                            fini         = false;
                            retour       = true;
                            for (int i = 1; i < MAX_A_B; i++) {
                                if (!tout_teste) {                                                                                                           //  tant qu'on trouve un itinéraire, on continue en partant du connecteur final en retour
                                    tco.recherche_itineraires(connecteur_retour, c_retour, l_retour);                                                        //  on recherche la suite
                                    fini     = false;                                                                                                        //  on continue
                                    retour   = true;                                                                                                         //  on ne peut continuer qu'en reculant
                                } else {
                                    break;                                                                                                                   //  si on ne trouve plus d'itinéraire, on sort
                                }
                            }
                            cherche_arrivee    = false;                                                                                                      //  pour chercher le point de depart la prochaine fois
                            if (tous_iti_tempo.size() > 0) {                                                                                                 //  on a trouve au moins un itinéraire
                                montre_itineraires = true;                                                                                                   //  on pourra les afficher
                            } else {
                                texte_affiche    = "Aucune route n'est possible avec ces deux extrémités";
                                couleur_affichee = POURPRE;
                                numero_iti       = numero_iti_debut;                                                                                         //  on redémarrera au dernier itinéraire affiché
                                efface_recherche();                                                                                                          //  on efface la recherche AVANT d'effacer les feux noirs
                                for (Pave pave0 : tous_paves) {                                                                                              //  on efface tous les feux noirs non clignotants
                                    if (pave0.feu_noir[0] && !pave0.feu_clignotant[0]) {
                                        pave0.feu_noir[0]       = false;
                                        pave0.feu_clignotant[0] = false;
                                    }
                                    if (pave0.feu_noir[1] && !pave0.feu_clignotant[1]) {
                                        pave0.feu_noir[1]       = false;
                                        pave0.feu_clignotant[1] = false;
                                    }
                                }
                            }
                            efface_recherche();
                    } else {                                                                                                                                 //  depart = arrivee (voulu pour effacer le train sur place et tous les itinéraires de même numéro)
                        Pave pave_double_clic  = tco.paves[c_trouve][l_trouve];                                                                              //  pavé sur lequel on a fait un double-clic
                        int numero_iti_courant = abs(pave_double_clic.numero_train1);                                                                        //  numero_iti du "double clic"
                        if (numero_iti_courant == 0) {
                            texte_affiche    = "Pas de train sur cette zone. Vous ne pouvez pas cliquer 2 fois à cet endroit";
                            couleur_affichee = POURPRE;                            
                            numero_iti         = numero_iti_debut;                                                                                           //  pour montrer les itinéraires à partir du premier
                            efface_recherche();
                        } else {                                                                                                                             //  il y a bien un trains sur ce pavé
                            //*********************************** effacement iti sur place *******************************************************
                            boolean efface             = false;
                            train = pupitre.trains[numero_iti_courant];                                                                                      //  la gestion train démarre à 0 et le numéro de train à 1
                            if (itineraire.numero_train != -1000) {                                                                                          //  on a un train sur l'itinéraire
                                if (train.vitesse == 0) {                                                                                                    //  il faut que le train soit à l'arret
                                    efface             = true;                                                                                               //  pour pouvoir continuer
                                    itineraire         = train.iti_train;                                                                                    //  simplification d'écriture. Ce n'est pas un transfert : on garde le même itinéraire
                                }
                            }
                            if (efface) {                                                                                                                    //  nota : on n'arrive pas à cet endroit si le train roule
                                train = pupitre.trains[abs(itineraire.numero_train)];                                                                        //  on a besoin du train concerné
                                duree_restante[abs(itineraire.numero_train)] = 0;
                                itineraire.duree_arret = 0;
                                int index = tous_iti.size()-1;
                                //-------------------- effacement de tous les itinéraires avec le meme numero train en négatif -------------
                                while (index > -1) {                                                                                                         //  on balai e tous les itinéraires en partant du bas
                                    if (tous_iti.get(index).numero_train == -abs(train.numero_train)                                                         //  on recherche tous les itinéraires dont le numero_train est le même, en négatif 
                                     || tous_iti.get(index).numero_train == -1000) {
                                        tous_iti.get(index).efface_itineraire();
                                        tous_iti.remove(index);                                                                                              //  on efface l'itinéraire
                                    } else {
                                        if (tous_iti.get(index).numero_train == abs(train.numero_train)) {
                                            for (Pave pave0 : tous_iti.get(index).paves_composant_iti) {
                                                pave0.carre_manuel = false;
                                            }
                                        }
                                    }
                                    index--;
                                }
                                tous_iti.trimToSize();                                                                                                       //  on n'a plus d'autre itinéraire affiche que celui qui contient le train
                                itineraire.efface_itineraire();                                                                                              //  on efface tout l'itinéraire où est le train, sauf les zones_occupées
                                //------------------- repositionnement du train --------------------------------------------------------------
                                prolonge_numero_train(itineraire);
                                Pave pave_signal_debut = itineraire.paves_composant_iti.get(0);                                                              //  à priori, le signal début est sur le premier pavé
                                for (Pave pave0 : itineraire.paves_composant_iti) {                                                                          //  on teste pour décaler le pavé du signal si la zone démarre par des appareils de voie
                                    if (!pave0.appareil_de_voie) {
                                        pave_signal_debut = pave0;                                                                                           //  le nouveau pavé signal début est le premier qui ne soit pas un appareil de voie
                                        break;
                                    }
                                }
                                Pave pave_signal_fin = itineraire.paves_composant_iti.get(itineraire.paves_composant_iti.size()-1);                          //  à priori, le signal fin est le dernier pavé
                                int total_paves = itineraire.paves_composant_iti.size();
                                for (int i = total_paves-1; i > -1; i--) {                                                                                   //  on teste pour décaler le pavé du signal si la zone finit par des appareils de voie
                                    if (!itineraire.paves_composant_iti.get(i).appareil_de_voie) {
                                        pave_signal_fin = itineraire.paves_composant_iti.get(i);                                                             //  le nouveau pavé signal fin est le dernier qui ne soit pas un appareil de voie
                                        break;
                                    }
                                }
                                if (pave_double_clic == pave_signal_debut && pave_signal_debut != pave_signal_fin) {                                         //----- si le pavé est le nouveau pavé signal debut
                                    //------------------------------------- on inverse le sens de circulation du train ----------------------
                                    Itineraire itineraire_copie = new Itineraire();                                                                          //  pour pouvoir inverser l'itinéraire, il faut en créer une copie
                                    int taille    = itineraire.paves_composant_iti.size();
                                    for (int i = 0; i < taille; i++) {                                                                                       //  on balaie tous les pavés de l'itinéraire raccourci
                                        itineraire_copie.paves_composant_iti.add(itineraire.paves_composant_iti.get(taille-1-i));                            //  on ajoute le pavé symétrique à l'itinéraire copie
                                        itineraire_copie.lames[i]       = itineraire.lames[taille-1-i];                                                      //  on copie la position des lames
                                        itineraire_copie.entree_pave[i] = 1-itineraire.entree_pave[taille-1-i];                                              //  on copie l'OPPOSE de l'entrée pavé (l'itinéraire est inversé)
                                    }
                                    itineraire.paves_composant_iti.clear();                                                                                  //  on efface les pavés composant iti de l'itinéraire
                                    for (int i = 0; i < taille; i++) {                                                                                       //  on recopie la copie de l'itinéraire modifié dans l'ancien itinéraire
                                        itineraire.paves_composant_iti.add(itineraire_copie.paves_composant_iti.get(i));
                                        itineraire.lames[i]       = itineraire_copie.lames[i];
                                        itineraire.entree_pave[i] = itineraire_copie.entree_pave[i];
                                    }
                                    train.retourne_train();
                                    train.transfert    = false;                                                                                              //  on n'est pas dans le cas d'un transfert. On est déjà sur le nouvel itinéraire, mais raccourci
                                    prolonge_numero_train(itineraire);
                                    for (int pos = 0; pos < itineraire.points_composant_iti.size(); pos++) {
                                        if (PVector.dist(itineraire.points_composant_iti.get(pos).coord, train.coord_fin_train) < 0.1) {                     //  on recherche la position future du train sur le nouvel itinéraire : c'est la fin qui devient de début
                                            train.debut_train  = pos;                                                                                        //  le train ne change pas de position, mais il est dans la nouvelle position du nouvel itinéraire
                                            break;
                                        }
                                    }
                                } else {                                                                                                                     //----- si le pavé n'est PAS le nouveau pavé signal debut
                                    //---------------------------------------- on garde le sens de circulation du train ---------------------
                                    if (pave_double_clic == pave_signal_fin) {                                                                               //----- si le pavé est le nouveau pavé signal fin
                                        train.transfert    = false;                                                                                          //  on n'est pas dans le cas d'un transfert. On est déjà sur le nouvel itinéraire, mais raccourci
                                        prolonge_numero_train(itineraire);
                                        for (int pos = 0; pos < itineraire.points_composant_iti.size(); pos++) {
                                            if (PVector.dist(itineraire.points_composant_iti.get(pos).coord, train.coord_debut_train) < 0.1) {               //  on recherche la position future du train sur le nouvel itinéraire
                                                train.debut_train  = pos;                                                                                    //  le train ne change pas de position, mais il est dans la nouvelle position du nouvel itinéraire
                                                break;
                                            }
                                        }
                                    }
                                }
                                itineraire.pave_debut      = itineraire.paves_composant_iti.get(0);                                                          //  on met à jour le pave_debut
                                itineraire.pave_fin        = itineraire.paves_composant_iti.get(itineraire.paves_composant_iti.size()-1);                    //  on met à jour le pave_fin
                                itineraire.iti_suivant     = null;                                                                                           //  on n'a plus d'iti_suivant
                                for (Zone zone1 : itineraire.zones_composant_iti) {
                                    if (zone1.paves_composant_zone.contains(itineraire.pave_fin)) {
                                        itineraire.zone_fin = zone1;                                                                                         //  on remet à jour la dernière zone
                                        break;
                                    }
                                }
                                //---------------------------- efface recherche --------------------------------------------
                                efface_recherche();
                                texte_affiche = ".";
                                couleur_affichee = BLANC;
                                if (itineraire.numero_train != -1000) {
                                    train = pupitre.trains[numero_iti_courant];
                                    train.zone_occupee_debut = train.iti_train.zones_composant_iti.get(0);
                                }
                                itineraire.iti_sur_place    = true;
                                itineraire.cycle            = false;
                                premier_pave                = null;
                                for (Pave pave0 : tous_paves) {                                                                                              //  on efface tous les feux_noirs
                                    pave0.feu_noir[0]       = false;
                                    pave0.feu_clignotant[0] = false;
                                    pave0.feu_noir[1]       = false;
                                    pave0.feu_clignotant[1] = false;
                                }
                            }
                            cursor(ARROW);
                            texte_affiche = "Effacement sur place de tous les itinéraires du train n°"+itineraire.numero_train;
                            couleur_affichee = OLIVE;
                        }
                    }
                } else {
                    cursor(curseur_iti, 0, 0);                                                                                                               //  changement de curseur pour selectionner le point d'arrivee
                    texte_affiche = "Point d'arrivée introuvable";
                    couleur_affichee = SABLE;
                    efface_recherche();
                }
            }
        } else {                                                                                                                                             //---------------- mouseButton == RIGHT-----------
            efface_recherche();
            texte_affiche = ".";
            couleur_affichee = BLANC;
            if (pave_feu_noir != null && !pave_feu_noir.occupe) {
                pave_feu_noir.feu_noir[cote_feu_noir]       = false;                                                                                         //  on efface le feu noir au point de départ
                pave_feu_noir.feu_clignotant[cote_feu_noir] = false;                                                                                         //  ce feu n'est pas clignotant
            }
            if (pave_1 != null && pave_1.numero_train1 != 0) {                                                                                               //  seulement si on a eu des feux clignotants effacés
                pave_1.feu_noir[cote_1]                 = true;                                                                                              //  on rallume les deux feux clignotants de la zone de fin
                pave_1.feu_clignotant[cote_1]           = true;
                pave_2.feu_noir[cote_2]                 = true;
                pave_2.feu_clignotant[cote_2]           = true;
            }
        }
    }
    //------------------------------------------------  recherche de zone ---------------------------------------------------------------------------------------------------------
    if (zone_recherchee) {
        boolean trouve_zone   = false;
        if (mouseButton == LEFT) {                                                                                                                           //---------------- mouseButton == LEFT-----------
            index    = 0;                                                                                                                                    //  index de la matrice
            if (!cherche_arrivee) {                                                                                                                          //  on cherche un point de depart
                texte_affiche = ".";
                couleur_affichee = BLANC;
                tco.recherche_connecteur(true);                                                                                                              //  on cherche un connecteur depart au niveau 0                                                                                 //  on cherche un connecteur depart au niveau 1
                pave = tco.paves[c_trouve][l_trouve];                                                                                                        //  le pavé selectionne
                for (Itineraire iti0 : tous_iti) {
                    if (iti0.zone_debut.paves_composant_zone.contains(pave) && !trouve_zone) {
                        //iti0.numero_train = numero_pupitre+1;
                        trouve_zone       = true;
                        zone_recherchee   = false;
                        efface_recherche();
                        break;
                    }
                }
                if (!trouve_zone) {
                    texte_affiche = "On ne peut affecter un train qu'à proximité du point de départ d'une route existante (le gros point clignotant)";
                    couleur_affichee = POURPRE;
                    zone_recherchee  = false;
                    cherche_arrivee  = false;
                    efface_recherche();
                    cursor(curseur_loco, 0, 0);
                    numero_point_train = -1;
                }
            }
        } else {                                                                                                                                             //---------------- mouseButton == RIGHT-----------
            efface_recherche();
            texte_affiche = ".";
            couleur_affichee = BLANC;
        }
    }
}
//************************************ mouseDragged() *************************************  
void mouseDragged() {
    //---------------------------------------------------- curseur vitesse/horloge ---------------------------------------
    if (pupitre.dans_les_pupitres) {
        int numero_pupitre = int((x_mouse-x_mouse_p)/2/pupitre.zoom_p)+1;                                                                                    //  simplification d'écriture
        if (pupitre.box_p[numero_pupitre] == 1 && !pupitre.bloque[numero_pupitre]) {
            hauteur_curseur[numero_pupitre] = int(max(0, min(127, 127*(curseur_down*pupitre.zoom_p+y_pupitre-mouseY)/(curseur_down-curseur_up)/pupitre.zoom_p)));
            if (!pupitre.horloge[numero_pupitre]) {                                                                                                          //--- si on n'est pas dans
                if (premier_pave != null) {
                    pupitre.bloque[numero_pupitre]  = true;
                    hauteur_curseur[numero_pupitre] = 0;
                } else {
                    if (affiche_exit && affiche_trains) {
                        hauteur_curseur[numero_pupitre] = 0;
                        texte_affiche_train   = "Il faut sortir de l'affichage du train (EXIT) pour pouvoir démarrer";
                        couleur_affiche_train = POURPRE;                                                  
                    } else {
                        pupitre.bloque[numero_pupitre] = false;
                        texte_affiche = ".";
                        couleur_affichee = BLANC;
                    }
                }
            } else {
                itineraire.duree_arret = int(0.5+(hauteur_curseur[numero_pupitre]*hauteur_curseur[numero_pupitre]/127));                                     //  croissance en x²
            }
        }
    }
    //-------------------------------------------------- supprimer, insérer ou ajouter un véhicule --------------------------
    if (affiche_trains && abs(mouseX-pmouseX) > 1) {
        Train train = pupitre.trains[choix_train];
        if (train.compo_train.size() > 0) {
            //------------------------- compte les engins moteurs ---------------
            int taille = train.compo_train.size();                                                                                                           //  on simplifie l'écriture
            int nombre_moteur = 0;                                                                                                                           //  initialistation
            for (int d = 0; d < 2; d++) {
                for (int u = 0; u < 10; u++) {
                    if (10*d+u < taille) {
                        if (train.compo_train.get(10*d+u).moteur) {
                            nombre_moteur++;
                        }
                    }
                }
            }
            boolean trouve = false;
            for (int d = 0; d < 2; d++) {
                for (int u = 0; u < 10; u++) {
                    if (!trouve) {                                                                                                                           // on continue. on s'arrêtera si trouve = true
                        //-------------------- on est dans un véhicule -----------------------------
                        if (mouseX > int((width-1366)/2+.5)+17+u*135 && mouseX < int((width-1366)/2+.5)+113+u*135                                            
                         && mouseY > (height-200)+17+d*65            && mouseY < (height-200)+63+d*65) {
                            memo_case = 10*d+u;
                            if (10*d+u < taille) {                                                                                                           //  si on n'a pas dépassé le nombre de véhicules
                                train.compo_train_bis.clear();                                                                                               //  on efface le nouvel ArrayList
                                if (mouseX < pmouseX) {                                                                                                      //  on zippe à gauche
                                    //-------------- on efface un véhicule ------------
                                    if (train.compo_train.size() == 1) {
                                        texte_affiche_train   = "Si on supprime ce dernier véhicule, on supprime aussi le train et son pupitre. Pour ne pas supprimer, appuyer sur le bouton 'annule'";
                                        couleur_affiche_train = SABLE;
                                        supprime_train = true;
                                    } else {
                                        //-------------- on supprime un engin moteur -------------
                                        if (nombre_moteur == 1 && train.compo_train.get(10*d+u).moteur) {
                                            texte_affiche_train   = "Si on supprime le dernier engin moteur, on supprime aussi le train et son pupitre. Pour ne pas supprimer, appuyer sur le bouton 'annule'";
                                            couleur_affiche_train = SABLE;
                                            supprime_train = true;
                                        } else {
                                            for (int i = 0; i < taille-1; i++) {
                                                if (i >= 10*d+u) {                                                                                           //  à partir de 10*d+u, on va décaler vers la gauche
                                                    trouve = true;                                                                                           //  on arrêtera après
                                                    train.compo_train_bis.add(train.compo_train.get(i+1));                                                   //  on recopie le véhicule suivant à la place du courant
                                                } else {
                                                    train.compo_train_bis.add(train.compo_train.get(i));                                                     //  on recopie le véhicule courant
                                                }
                                            }
                                        }
                                    }
                                } else {                                                                                                                     //  on zippe à droite
                                    //-------------- on insère un véhicule ---------------
                                    for (int i = 0; i < taille; i++) {
                                        if (i == 10*d+u) {
                                            trouve = true;                                                                                                   //  on arrêtera après
                                            vehicule = new VehiculeCopy(-1);                                                                                 //  on crée un nouveau véhicule ROUGE
                                            train.compo_train_bis.add(vehicule.copy());                                                                      //  on l'ajoute
                                        } else {
                                            if (i > 10*d+u) {
                                                train.compo_train_bis.add(train.compo_train.get(i-1));                                                       //  on recopie le véhicule précédent
                                            } else {
                                                train.compo_train_bis.add(train.compo_train.get(i));                                                         //  on recopie le véhicule courant
                                            }
                                        }
                                    }
                                    train.compo_train_bis.add(train.compo_train.get(taille-1));                                                              //  on place le dernier véhicule un cran plus loin à droite
                                }
                            } else {
                                //------------------ on ajoute un véhicule au bout à droite ------------------
                                if (10*d+u == taille && mouseX > pmouseX) {                                                                                  //  on est juste après le dernier véhicule et on zippe vers la droite
                                    trouve = true;                                                                                                           //  on arrêtera après                                                    
                                    train.compo_train_bis.clear();                                                                                           //  on efface le nouvel ArrayList
                                    for (int i = 0; i < taille; i++) {
                                        train.compo_train_bis.add(train.compo_train.get(i));
                                    }
                                    vehicule = new VehiculeCopy(-1);                                                                                         //  on crée un nouveau véhicule ROUGE
                                    train.compo_train_bis.add(vehicule.copy());                                                                              //  on l'ajoute
                                }
                            }
                            affiche_exit = false;
                        }
                    }
                }
            }
        }
    }
}
//--------------------------------------------- efface recherche() --------------------------------------------
void efface_recherche() {
    for (int i = 1; i < INDEX_MAX; i++) {                                                                                                                    //  nettoyage complet de la matrice
        for (int j = 0; j < 6; j++) {
            iti[i][j] = 0;
        }
    }
    for (Pave pave0 : tous_paves) {
        pave0.choisi      = false;
    }
    dessine_tous_iti();
    index              = 0;                                                                                                                                  //  index de la matrice
    fini               = false;                                                                                                                              //  l'itinéraire n'est pas fini...
    retour             = false;                                                                                                                              //  on commence par avancer
    cherche_arrivee    = false;                                                                                                                              //  pour chercher le point de depart la prochaine fois
    numero_iti         = numero_iti_debut;                                                                                                                   //  pour montrer les itinéraires à partir du premier
    itineraire_demande = false;
    cursor(ARROW);
}
//*********************************** mouseReleased() **************************************
void mouseReleased() {
}
