//************************************ mouseClicked() *************************************
void mouseClicked() {
    //----------------------------- réaffichage du CabSignal après validation du temps d'arrêt ---------------------------
    if (itineraire != null && abs(itineraire.numero_train) != 1000) {
        train_pupitre(abs(itineraire.numero_train));
        if (pupitre.horloge[num_train_pupitre] && mouseButton == RIGHT) {
            pupitre.horloge[num_train_pupitre] = false;
            hauteur_curseur[num_train_pupitre] = 0;
            if (premier_pave == null) {
                texte_affiche    = "Le pointeur 'flèche' permet de choisir la consigne de vitesse en déplaçant le curseur";
            } else {
                texte_affiche    = "Choisissez la suite du chaînage des routes du cycle";
            }
            couleur_affichee = SABLE;
            cursor(ARROW);
            //----------------------- faire clignoter les feux noirs de la dernière zone en cas de cycle ----------------------------------
            if (premier_pave != null || !itineraire.cycle) {                                                                                       //  si le cycle n'est pas terminé ou si on n'est pas dans un cycle 
                int compteur_paves = -1;                                                                                                           //  on va avoir besoin du rang du pavé dans l'itinéraire
                for (Pave pave0 : itineraire.paves_composant_iti) {                                                                                //  on balaie tous les pavés jusqu'à trouver le premier feu noir de la zone de fin de l'itinéraire
                    compteur_paves++;
                    if (itineraire.zone_fin.paves_composant_zone.contains(pave0)) {                                                                //  si la zone de fin contient le pavé en cours, c'est le premier pavé de la zone de fin
                        if (!pave0.appareil_de_voie) {
                            pave0.feu_noir[itineraire.entree_pave[compteur_paves]]       = true;                                                   //  on crée feu noir à cet endroit, côté entree_pave
                            pave0.feu_clignotant[itineraire.entree_pave[compteur_paves]] = true;                                                   //  on le fait clignoter
                            pave_1 = pave0;
                            cote_1 = itineraire.entree_pave[compteur_paves];
                            break;                                                                                                                 //  on sort : le premier pavé de la zone de fin est traité
                        }
                    }
                }                
                int taille = itineraire.paves_composant_iti.size();                                                                                //  taille de paves_composant_iti
                pave = itineraire.paves_composant_iti.get(taille-1);                                                                               //  pave est le dernier pavé de l'itinéraire
                pave.feu_noir[1-itineraire.entree_pave[taille-1]]       = true;                                                                    //  on cherche un feu_noir coté opposé à l'entree du dernier pavé                                                                          
                pave.feu_clignotant[1-itineraire.entree_pave[taille-1]] = true;                                                                    //  si on l'a trouvé, on le fait clignoter
                pave_2 = pave;
                cote_2 = 1-itineraire.entree_pave[taille-1];
            }
        }
    }
    //**************************************************************************************************************************************************************************************
    //------------------------------------------------------------------- montre itinéraires -----------------------------------------------------------------------------------------------
    if (montre_itineraires) {
        if (mouseButton == LEFT) {                                                                                                                 //----- mouseButton == LEFT --------------
            numero_iti++;
            if (numero_iti < tous_iti_tempo.size()) {
                texte_affiche = "Route numéro "+str(numero_iti-numero_iti_debut)+"/"+str(tous_iti_tempo.size()-numero_iti_debut-1)
                               +". Cliquez GAUCHE pour continuer l'affichage. Cliquez DROIT pour choisir cette route";
                couleur_affichee = SABLE;
                if (itineraire != null && itineraire.numero_train == -1000) {                                                                      //  si l'itineraire n'est pas null ET il n'y a pas de train affecté
                    itineraire.numero_train = 1000;                                                                                                //      au départ, l'itinéraire doit avoir le numéro_train = 1000          
                }                                                                                                                                  //      c'est aussi l'itinéraire précédent dans la boucle montrant les itinéraires trouvés
                itineraire = tous_iti_tempo.get(numero_iti);                                                                                       //  on passe au nouvel itinéraire (ou le 1er, si c'est le début de la boucle
                for (Itineraire iti0 : tous_iti_tempo) {                                                                                           //  dans tous les iti_tempo
                    if (iti0.numero_train == 1000) {                                                                                               //      si le numero_train de l'itinéraire est à 1000 (il est de couleur SABLE)
                        for (Pave pave0 : iti0.paves_composant_iti) {                                                                              //      pour tous les pavés de l'itinéraire
                            pave0.affiche_iti_tempo = false;                                                                                       //          on efface l'iti tempo
                        }                        
                    }
                }                                                                                                                                  //  à ce stade, tous les itinéraires tempo sont effacés à l'écran
                for (Pave pave0 : itineraire.paves_composant_iti) {                                                                                //  pour tous les pavés de "itinéraire"
                    pave0.affiche_iti_tempo = true;                                                                                                //      on affiche l'iti_tempo
                    pave0.couleur_rail      = SABLE;                                                                                               //      il sera de couleur SABLE et ce sera le seul affiché
                }
                itineraire.numero_train   = -1000;                                                                                                 //  il aura le numero_train à -1000 (nécessaire si on sort de la boucle)
                iti_tempo = true;                                                                                                                  //  prépare l'enregistrement dans les vrais itinéraires
            } else {                                                                                                                               //  on a balaye tous les itinéraires de l'ArrayList des iti_tempo
                if (tous_iti_tempo.size() > 0) {                                                                                                   //  on a dépassé le nombre d'itinéraires trouvés par le programme
                    texte_affiche = "Cliquez DROIT pour effacer les recherches en cours. Cliquez GAUCHE pour balayer à nouveau toutes les routes trouvées ("+max_index+" index utilisés/"+max_recherche+" étapes)";
                    numero_iti = numero_iti_debut;                                                                                                 //  on repart du début pour pouvoir balayer les iti_tempo à nouveau, en ne touchant pas à ceux déjà traités
                    for (Itineraire iti0 : tous_iti_tempo) {
                        for (Pave pave0 : iti0.paves_composant_iti) {
                            pave0.affiche_iti_tempo = false;                                                                                       //  plus aucun iti_tempo ne sera affiché
                        }
                    }
                    iti_tempo = false;                                                                                                             //  on n'enregistrera aucun itinéraire
                }
            }
        } else {                                                                                                                                   //----- mouseButton == RIGHT --------------
            //------------------------------------ validation du choix d'itinéraire -----------------------
            cursor(ARROW);
            max_index     = 0;
            max_recherche = 0;
            boolean itineraire_choisi = true;
            if (iti_tempo) {
                for (Pave pave0 : itineraire.paves_composant_iti) {
                    pave0.affiche_iti_tempo = true;
                    pave0.couleur_rail      = BLANC;
                }
                tous_iti.add(itineraire);                                                                                                          //  l'itinéraire temporaire passe à réel validé
                efface_iti_tempo(1000);
                //--------------------------- zone double ------------------------------------------------                
                int numero_train_cherche = itineraire.pave_debut.numero_train1;
                for (Pave pave0 : itineraire.paves_composant_iti) {
                }
                int nb_iti = tous_iti.size();
                for (int num_iti = nb_iti-1; num_iti > -1; num_iti--) {
                    Itineraire iti0 = tous_iti.get(num_iti);
                     if (itineraire != iti0 && iti0.iti_suivant == null                                                                            //  si les 2 itinéraires sont différents ET que l'itinéraire suivant est null 
                     && (abs(iti0.numero_train) == numero_train_cherche || numero_train_cherche == 0)                                              //  ET que l'itinéraire en test a bien le bon numéro de train OU l'itinéraire a un numéro de train = 0
                     && (iti0.zone_fin.paves_composant_zone.contains(itineraire.pave_debut)                                                        //  ET que le pavé de début de l'itinéraire est dans la zone de fin de iti0
                     || iti0.pave_debut == itineraire.pave_debut)) {                                                                               //  OU les deux itinéraires démarrent par le même pavé
                        iti0.iti_suivant        = itineraire;                                                                                      //  on met à jour l'itinéraire suivant
                        itineraire.numero_train = -abs(iti0.numero_train);                                                                         //  on met à jour le numero de train de l'itinéraire suivant (négatif, bien sur)                                
                        break;                                    
                     }
                }
                //---------------------------- recherche de cycle -----------------------------------------
                if (iti_cycle) {                                                                                                                   //  si on a choisi l'icone "cycle" dans le menu
                    itineraire.cycle = true;                                                                                                       //  l'itinéraire est donc un cycle. On crée un cycle ou on est déjà dans un cycle
                    if (premier_pave == null) {                                                                                                    //  si on n'est pas dans un cycle en cours, c'est qu'on est en train de créer un cycle
                        premier_pave = itineraire.paves_composant_iti.get(0);                                                                      //  on mémorise le premier pavé
                    }
                }
                if (iti_cycle) {                                                                                                                   //  si l'itinéraire est un cycle
                    Pave dernier_pave = itineraire.paves_composant_iti.get(itineraire.paves_composant_iti.size()-1);                               //  on calcule le dernier pavé de l'itinéraire
                    if (dernier_pave.ID_zone.equals(premier_pave.ID_zone) || dernier_pave.occupe) {                                                //--- si on a bouclé le cycle (le premier et le dernier pavé de l'itinéraire appartiennent à la même zone)
                        premier_pave   = null;
                        train_pupitre(itineraire.numero_train);
                        pupitre.bloque[num_train_pupitre] = false;                                                                                 //  si on a bouclé, on débloque le pupitre
                        for (Itineraire iti0 : tous_iti) {
                            if (abs(iti0.numero_train) == abs(itineraire.numero_train)) {
                                for (Pave pave0 : iti0.paves_composant_iti) {                                                                      //  on efface tous les feux noirs de l'itinéraire
                                    if (pave0.feu_noir[0]) {
                                        pave0.feu_noir[0]       = false;
                                        pave0.feu_clignotant[0] = false;
                                    }
                                    if (pave0.feu_noir[1]) {
                                        pave0.feu_noir[1]       = false;
                                        pave0.feu_clignotant[1] = false;
                                    }
                                }
                            }
                        }
                        //------------------------- efface les iti_tempo qui ont ce numéro de train -------------
                        efface_iti_tempo(itineraire.numero_train);
                    }
                }
            } else {
                efface_iti_tempo(-1000);
            }
            if (numero_iti == numero_iti_debut) {
                texte_affiche = "Aucune route sélectionnée";
                itineraire_choisi = false;
                efface_recherche();
                itineraire.cycle            = false;
                premier_pave                = null;
                for (Pave pave0 : itineraire.paves_composant_iti) {                                                                                //  on efface tous les feux_noirs de l'itinéraire
                    pave0.feu_noir[0]       = false;
                    pave0.feu_clignotant[0] = false;
                    pave0.feu_noir[1]       = false;
                    pave0.feu_clignotant[1] = false;
                }
                cursor(ARROW);
            } else {
                //---------------------------------- arret du clignotement des feux noirs avant de passer à l'affichage de l'horloge ---------------------------
                if (itineraire.numero_train != -1000) {
                    train_pupitre(abs(itineraire.numero_train));
                    pupitre.horloge[num_train_pupitre] = true;
                    for (Pave pave0 : itineraire.paves_composant_iti) {                                                                            //  on balaie tous les pavés jusqu'à trouver le premier feu noir
                        if (pave0.feu_noir[0]) {                                                                                                   //  ----- on teste le côté 0
                            pave0.feu_clignotant[0] = false;                                                                                       //  on arrête le clignotement de ce premier feu noir
                        }
                        if (pave0.feu_noir[1]) {                                                                                                   //  ----- on teste le côté 1
                            pave0.feu_clignotant[1] = false;                                                                                       //  on arrête le clignotement de ce premier feu noir
                        }
                    }
                }
                texte_affiche = "La route n° "+(numero_iti+1)+" est sélectionnée";
            }
            couleur_affichee = OLIVE;
            montre_itineraires = false;
            zone_recherchee    = false;
            efface_recherche();
            //----------------------------- effacer tous les feux noirs et affecter un train -----------------------------            
            if (itineraire_choisi) {
                if (itineraire.numero_train == -1000) {                                                                                            //  ---------- si l'itinéraire n'est pas occupé par un train (=> numero_train = -1000)
                    int compteur_paves = 0;
                    for (Pave pave0 : itineraire.paves_composant_iti) {                                                                            //  on efface tous les feux noirs, sauf le premier
                        if (pave0.feu_noir[0]) {
                            compteur_paves++;
                            if (compteur_paves != 1) {
                                pave0.feu_noir[0]       = false;
                                pave0.feu_clignotant[0] = false;
                            }
                        }
                        if (pave0.feu_noir[1]) {
                            compteur_paves++;
                            if (compteur_paves != 1) {
                                pave0.feu_noir[1]       = false;
                                pave0.feu_clignotant[1] = false;
                            }
                        }
                    }
                    itineraire.paves_composant_iti.get(0).feu_noir[itineraire.entree_pave[0]]       = true;                                        //  on met un feu noir au début de la zone de départ
                    itineraire.paves_composant_iti.get(0).feu_clignotant[itineraire.entree_pave[0]] = false;                                       //  il n'est pas clignotant
                    nb_pupitres = 0;
                    for (int numero_pupitre0 : liste_trains) {
                        if (numero_pupitre0 != 0) {
                            nb_pupitres++;
                        }
                    }
                    nb_pupitres++;
                    liste_trains.append(nb_pupitres);                                                                                              //  on ajoute un train : ajout du train taille_pupitre+1 dans la liste 
                    itineraire.numero_train   = liste_trains.size();                                                                               //  le numero de train est égal à la taille de la liste des trains
                    int numero_train = itineraire.numero_train;
                    pupitre.trains[numero_train] = new Train();
                    vehicule = new VehiculeCopy(0);
                    pupitre.trains[numero_train].compo_train.add(vehicule.copy());
                    vehicule = new VehiculeCopy(9);
                    pupitre.trains[numero_train].compo_train.add(vehicule.copy());
                    vehicule = new VehiculeCopy(10);
                    pupitre.trains[numero_train].compo_train.add(vehicule.copy());
                    vehicule = new VehiculeCopy(12);
                    pupitre.trains[numero_train].compo_train.add(vehicule.copy());
                    vehicule = new VehiculeCopy(13);
                    pupitre.trains[numero_train].compo_train.add(vehicule.copy());
                    pupitre.trains[numero_train].numero_pupitre = nb_pupitres;
                    if (itineraire.cycle) {                                                                                                        //  si on a choisi l'icone "cycle" dans le menu
                        train_pupitre(itineraire.numero_train);
                        pupitre.bloque[num_train_pupitre]  = true;                                                                                 //  si c'est sur un cycle qu'on pose le train, on bloque le pupitre
                        hauteur_curseur[num_train_pupitre] = 0;                                                                                    //  en bloquant, on met le curseur à 0
                    }
                } else {
                    train_pupitre(abs(itineraire.numero_train));
                    if (pupitre.horloge[num_train_pupitre]) {
                        cursor(curseur_horloge, 25,25);
                        texte_affiche    = "Le pointeur 'horloge' permet de choisir la durée d'arrêt en déplaçant le curseur. Clic DROIT pour valider la durée d'arrêt en gare";
                        couleur_affichee = SABLE;                      
                    }
                }
            }
        }
    }
    //**********************************************************************************************************************************
    //********************************************************** menu ******************************************************************
    if (mouseX < width-CURSEUR-2 && (mouseY >= height-180 && mouseY < height-50) && !affiche_trains) {
        //if (couleur_affichee == OLIVE || couleur_affichee == BLANC || (couleur_affichee == POURPRE)) {
            switch (position_bouton) {
                //--------------------------------------- Zoom + -----------------------------------------
                case 0:
                    if (mouseButton == LEFT) {
                        if (aide) {
                            texte_aide    = loadImage("data/Aide/Aide zoom.png");
                            largeur_texte = 623;
                            hauteur_texte = 114;
                        } else {
                            zoom_change = 1;
                            key_zoom_pupitre();
                        }
                        break;
                    } else {
                        zoom_change = 1;
                        key_zoom_tco();
                    }
                    iti_cycle     = false;
                    break;
                //--------------------------------------- Zoom - -----------------------------------------
                case 1:
                    if (mouseButton == LEFT) {
                        if (aide) {
                            texte_aide    = loadImage("data/Aide/Aide zoom.png");
                            largeur_texte = 623;
                            hauteur_texte = 114;
                        } else {
                            zoom_change = -1;
                            key_zoom_pupitre();
                        }
                        break;
                    } else {
                        zoom_change = -1;
                        key_zoom_tco();
                    }
                    iti_cycle     = false;
                    break;
                //--------------------------------------- Affiche meilleur itinéraire -------------------------------------------
                /*case 2:
                    if (aide) {
                        texte_aide    = loadImage("data/Aide/Aide meilleur itineraire.png");
                        largeur_texte = 615;
                        hauteur_texte = 102;
                    } else {
                        montre_itineraires = true;
                        cursor(ARROW);
                    }
                    iti_cycle     = false;
                    break;*/
                //--------------------------------------- Recherche itinéraires -------------------------------------------
                case 2:
                    if (aide) {
                        texte_aide    = loadImage("data/Aide/Aide recherche routes simples.png");
                        largeur_texte = 624;
                        hauteur_texte = 383;
                    } else {
                        if (premier_pave != null) {
                            texte_affiche = "Vous ne pouvez pas créer de nouvelle route avant d'avoir fini le cycle";
                            couleur_affichee = POURPRE;
                            cursor(ARROW);
                        } else {
                            texte_affiche = "Cliquez GAUCHE sur le point de DEPART, à proximité d'un retrait. Clic DROIT pour ne pas choisir de route";
                            couleur_affichee = SABLE;
                            affiche_grille     = false;
                            itineraire_demande = true;
                            montre_itineraires = false;
                            zone_recherchee    = false;
                            cursor(curseur_iti, 0, 0);
                        }
                        iti_cycle     = false;
                    }
                    break;
                //--------------------------------------- Itinéraires cycliques -------------------------------------------
                case 3:
                    if (aide) {
                        texte_aide    = loadImage("data/Aide/Aide recherche routes cycliques.png");
                        largeur_texte = 623;
                        hauteur_texte = 418;
                    } else {
                        texte_affiche = "Cliquez GAUCHE sur le point de DEPART, à proximité d'un retrait. Clic DROIT pour ne pas choisir de route";
                        couleur_affichee   = SABLE;
                        affiche_grille     = false;
                        itineraire_demande = true;
                        montre_itineraires = false;
                        zone_recherchee    = false;
                        cursor(curseur_cycle, 0, 0);
                    }
                    iti_cycle     = true;
                    break;
                //--------------------------------------- Pupitre -------------------------------------------
                /*case 4:
                    if (aide) {
                        texte_aide    = loadImage("data/Aide/Aide pupitre.png");
                        largeur_texte = 615;
                        hauteur_texte = 278;
                    } else {
                        cursor(ARROW);
                    }
                    iti_cycle     = false;
                    break;*/
                //--------------------------------------- Fichier -----------------------------------------
                /*case 6:
                    if (aide) {
                        texte_aide    = loadImage("data/Aide/Aide fichier.png");
                        largeur_texte = 615;
                        hauteur_texte = 369;
                    } else {
                        sauve_TCO();
                        fill(FOND);
                        rect(0, 0, width, height);
                        selectInput("Selectionnez un fichier pour charger le reseau : ", "fileSelected");
                    }
                    iti_cycle     = false;
                    break;
                //--------------------------------------- Sauve -----------------------------------------
                case 7:
                    if (aide) {
                        texte_aide    = loadImage("data/Aide/Aide sauve.png");
                        largeur_texte = 615;
                        hauteur_texte = 265;
                    } else {
                        sauve = true;
                        sauve_TCO();
                        sauve = false;
                    }
                    iti_cycle     = false;
                    break;*/
                //--------------------------------------- Train -------------------------------------------
                case 4:
                    if (aide) {
                        texte_aide    = loadImage("data/Aide/Aide composition des trains.png");
                        largeur_texte = 615;
                        hauteur_texte = 561;
                    } else {
                        affiche_trains  = true;
                        choix_train = -1;
                    }
                    iti_cycle     = false;
                    break;
                //--------------------------------------- Aide -----------------------------------------
                case 5:
                    aide = !aide;
                    if (aide) {
                        texte_aide    = loadImage("data/Aide/Aide aide.png");
                        largeur_texte = 623;
                        hauteur_texte = 113;
                    }
                    iti_cycle     = false;
                    break;
                default:
            }
        /*} else {
            if (couleur_affichee == SABLE) {
                texte1      = texte_affiche;
                couleur1    = couleur_affichee;
                texte_affiche = "Cliquez GAUCHE DANS LE MENU pour revenir à l'action à terminer avant d'en entreprendre une autre";
                couleur_affichee = POURPRE;
            } else {
                texte_affiche    = texte1;
                couleur_affichee = couleur1;               
            }
        }*/
    }
}
